#include "dtypes.h"
!===================================================
! DO NOT EDIT THIS FILE, it was generated using /glade/u/home/santos/Utilities/genf90.pl 
! Any changes you make to this file may be lost
!===================================================

! Flag representing compiler support of Fortran 2003's
! ieee_arithmetic intrinsic module.
#if defined CPRIBM || defined CPRPGI || defined CPRINTEL ||  defined CPRCRAY || defined CPRNAG
#define HAVE_IEEE_ARITHMETIC
#endif

module shr_infnan_mod
!---------------------------------------------------------------------
! Module to test for IEEE Inf and NaN values, which also provides a
! method of setting +/-Inf and signaling or quiet NaN.
!
# 13 "shr_infnan_mod.F90.in"
! All functions are elemental, and thus work on arrays.
!---------------------------------------------------------------------
# 15 "shr_infnan_mod.F90.in"
! To test for these values, just call the corresponding function, e.g:
!
!   var_is_nan = shr_infnan_isnan(x)
!
! You can also use it on arrays:
!
!   array_contains_nan = any(shr_infnan_isnan(my_array))
!
!---------------------------------------------------------------------
! To generate these values, assign one of the provided derived-type
! variables to a real:
!
!   use shr_infnan_mod, only: nan => shr_infnan_nan, &
!                             inf => shr_infnan_inf, &
!                             assignment(=)
!   real(r4) :: my_nan
!   real(r8) :: my_inf_array(2,2)
!   my_nan = nan
!   my_inf_array = inf
!
! Keep in mind that "shr_infnan_nan" and "shr_infnan_inf" cannot be
# 36 "shr_infnan_mod.F90.in"
! passed to functions that expect real arguments. To pass a real
! NaN, you will have to use shr_infnan_nan to set a local real of
! the correct kind.
!---------------------------------------------------------------------

use shr_kind_mod, only: &
     r4 => SHR_KIND_R4, &
     r8 => SHR_KIND_R8

#ifdef HAVE_IEEE_ARITHMETIC

! If we have IEEE_ARITHMETIC, NaN tests are provided
! for us.
use, intrinsic :: ieee_arithmetic, only: &
     shr_infnan_isnan => ieee_is_nan

#else

! If we don't use Fortran 2003 IEEE module,
! use the old code to do all NaN/Inf testing.

use shr_test_infnan_mod, only: &
     shr_infnan_isnan => shr_test_infnan_isnan, &
     shr_infnan_isinf => shr_test_infnan_isinf, &
     shr_infnan_isposinf => shr_test_infnan_isposinf, &
     shr_infnan_isneginf => shr_test_infnan_isneginf

#endif

implicit none
private
save

# 69 "shr_infnan_mod.F90.in"
! Test functions for NaN/Inf values.
public :: shr_infnan_isnan
public :: shr_infnan_isinf
public :: shr_infnan_isposinf
public :: shr_infnan_isneginf

#ifdef HAVE_IEEE_ARITHMETIC

! If we do have the IEEE intrinsics, define the
# 78 "shr_infnan_mod.F90.in"
! inf test functions here.
# 79 "shr_infnan_mod.F90.in"
interface shr_infnan_isinf
   ! TYPE double,real
   module procedure shr_infnan_isinf_double
   ! TYPE double,real
   module procedure shr_infnan_isinf_real
end interface

# 84 "shr_infnan_mod.F90.in"
interface shr_infnan_isposinf
   ! TYPE double,real
   module procedure shr_infnan_isposinf_double
   ! TYPE double,real
   module procedure shr_infnan_isposinf_real
end interface

# 89 "shr_infnan_mod.F90.in"
interface shr_infnan_isneginf
   ! TYPE double,real
   module procedure shr_infnan_isneginf_double
   ! TYPE double,real
   module procedure shr_infnan_isneginf_real
end interface

#endif

! Derived types for generation of NaN/Inf
! Even though there's no reason to "use"
! the types directly, Lahey breaks if you make
! shr_infnan_nan public, but shr_infnan_nan_type
! private.
public :: shr_infnan_nan_type
public :: shr_infnan_inf_type
public :: assignment(=)

! Type representing Not A Number.
type :: shr_infnan_nan_type
   logical :: quiet = .false.
end type shr_infnan_nan_type

! Type representing +/-Infinity.
type :: shr_infnan_inf_type
   logical :: positive = .true.
end type shr_infnan_inf_type

! Allow assigning reals to NaN or Inf.
# 116 "shr_infnan_mod.F90.in"
interface assignment(=)
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_0d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_1d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_2d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_3d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_4d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_5d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_6d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_7d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_0d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_1d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_2d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_3d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_4d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_5d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_6d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_nan_7d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_0d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_1d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_2d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_3d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_4d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_5d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_6d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_7d_double
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_0d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_1d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_2d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_3d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_4d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_5d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_6d_real
   ! TYPE double,real
   ! DIMS 0,1,2,3,4,5,6,7
   module procedure set_inf_7d_real
end interface

! Initialize objects of NaN/Inf type for other modules to use.

! Default NaN is signaling, but also provide snan and qnan to choose
! explicitly.
type(shr_infnan_nan_type), public, parameter :: shr_infnan_nan = &
     shr_infnan_nan_type(.false.)
type(shr_infnan_nan_type), public, parameter :: shr_infnan_snan = &
     shr_infnan_nan_type(.false.)
type(shr_infnan_nan_type), public, parameter :: shr_infnan_qnan = &
     shr_infnan_nan_type(.true.)

! Default Inf is positive, but provide posinf to go with neginf.
type(shr_infnan_inf_type), public, parameter :: shr_infnan_inf = &
     shr_infnan_inf_type(.true.)
type(shr_infnan_inf_type), public, parameter :: shr_infnan_posinf = &
     shr_infnan_inf_type(.true.)
type(shr_infnan_inf_type), public, parameter :: shr_infnan_neginf = &
     shr_infnan_inf_type(.false.)

# 144 "shr_infnan_mod.F90.in"
contains

#ifdef HAVE_IEEE_ARITHMETIC

!---------------------------------------------------------------------
# 149 "shr_infnan_mod.F90.in"
! TEST FUNCTIONS
!---------------------------------------------------------------------
# 151 "shr_infnan_mod.F90.in"
! The "isinf" functions simply call "isposinf" and "isneginf".
!---------------------------------------------------------------------

! TYPE double,real
# 155 "shr_infnan_mod.F90.in"
elemental function shr_infnan_isinf_double(x) result(isinf)
  real(r8), intent(in) :: x
  logical :: isinf

  isinf = shr_infnan_isposinf(x) .or. shr_infnan_isneginf(x)

end function shr_infnan_isinf_double
! TYPE double,real
# 155 "shr_infnan_mod.F90.in"
elemental function shr_infnan_isinf_real(x) result(isinf)
  real(r4), intent(in) :: x
  logical :: isinf

  isinf = shr_infnan_isposinf(x) .or. shr_infnan_isneginf(x)

end function shr_infnan_isinf_real

!---------------------------------------------------------------------
# 164 "shr_infnan_mod.F90.in"
! The "isposinf" and "isneginf" functions get the IEEE class of a
! real, and test to see if the class is equal to ieee_positive_inf
! or ieee_negative_inf.
!---------------------------------------------------------------------

! TYPE double,real
# 170 "shr_infnan_mod.F90.in"
elemental function shr_infnan_isposinf_double(x) result(isposinf)
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_class, &
       ieee_positive_inf, &
       operator(==)
  real(r8), intent(in) :: x
  logical :: isposinf

  isposinf = (ieee_positive_inf == ieee_class(x))

end function shr_infnan_isposinf_double
! TYPE double,real
# 170 "shr_infnan_mod.F90.in"
elemental function shr_infnan_isposinf_real(x) result(isposinf)
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_class, &
       ieee_positive_inf, &
       operator(==)
  real(r4), intent(in) :: x
  logical :: isposinf

  isposinf = (ieee_positive_inf == ieee_class(x))

end function shr_infnan_isposinf_real

! TYPE double,real
# 183 "shr_infnan_mod.F90.in"
elemental function shr_infnan_isneginf_double(x) result(isneginf)
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_class, &
       ieee_negative_inf, &
       operator(==)
  real(r8), intent(in) :: x
  logical :: isneginf

  isneginf = (ieee_negative_inf == ieee_class(x))

end function shr_infnan_isneginf_double
! TYPE double,real
# 183 "shr_infnan_mod.F90.in"
elemental function shr_infnan_isneginf_real(x) result(isneginf)
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_class, &
       ieee_negative_inf, &
       operator(==)
  real(r4), intent(in) :: x
  logical :: isneginf

  isneginf = (ieee_negative_inf == ieee_class(x))

end function shr_infnan_isneginf_real

#endif

!---------------------------------------------------------------------
# 198 "shr_infnan_mod.F90.in"
! GENERATION FUNCTIONS
!---------------------------------------------------------------------
! Two approaches for generation of NaN and Inf values:
!   1. With Fortran 2003, use the ieee_value intrinsic to get a value
!      from the corresponding class. These are:
!       - ieee_signaling_nan
!       - ieee_quiet_nan
!       - ieee_positive_inf
!       - ieee_negative_inf
!   2. Without Fortran 2003, set the IEEE bit patterns directly.
!      Use BOZ literals to get an integer with the correct bit
!      pattern, then use "transfer" to transfer those bits into a
!      real.
!---------------------------------------------------------------------

! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_0d_double(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r8), intent(out) :: output
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_0d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_1d_double(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_1d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_2d_double(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_2d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_3d_double(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_3d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_4d_double(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:,:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_4d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_5d_double(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:,:,:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_5d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_6d_double(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:,:,:,:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_6d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_7d_double(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:,:,:,:,:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_7d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_0d_real(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r4), intent(out) :: output
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_0d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_1d_real(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_1d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_2d_real(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_2d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_3d_real(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_3d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_4d_real(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:,:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_4d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_5d_real(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:,:,:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_5d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_6d_real(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:,:,:,:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_6d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_nan_7d_real(output, nan)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_signaling_nan, &
       ieee_quiet_nan, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: snan_pat = Z'7FA00000'
  integer(i4), parameter :: qnan_pat = Z'7FC00000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: snan_pat = Z'7FF4000000000000'
  integer(i8), parameter :: qnan_pat = Z'7FF8000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:,:,:,:,:,:)
  type(shr_infnan_nan_type), intent(in) :: nan

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (nan%quiet) then
     tmp = ieee_value(tmp, ieee_quiet_nan)
  else
     tmp = ieee_value(tmp, ieee_signaling_nan)
  end if
#else
  if (nan%quiet) then
     tmp = transfer(qnan_pat, tmp)
  else
     tmp = transfer(snan_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_nan_7d_real

! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_0d_double(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r8), intent(out) :: output
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_0d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_1d_double(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_1d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_2d_double(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_2d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_3d_double(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_3d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_4d_double(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:,:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_4d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_5d_double(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:,:,:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_5d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_6d_double(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:,:,:,:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_6d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_7d_double(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (102 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r8), intent(out) :: output(:,:,:,:,:,:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r8) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_7d_double
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_0d_real(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r4), intent(out) :: output
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_0d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_1d_real(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_1d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_2d_real(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_2d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_3d_real(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_3d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_4d_real(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:,:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_4d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_5d_real(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:,:,:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_5d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_6d_real(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:,:,:,:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_6d_real
! TYPE double,real
! DIMS 0,1,2,3,4,5,6,7
pure subroutine set_inf_7d_real(output, inf)
#ifdef HAVE_IEEE_ARITHMETIC
  use, intrinsic :: ieee_arithmetic, only: &
       ieee_positive_inf, &
       ieee_negative_inf, &
       ieee_value
#else
#if (101 == TYPEREAL)
  use shr_kind_mod, only: &
       i4 => shr_kind_i4
  integer(i4), parameter :: posinf_pat = Z'7F800000'
  integer(i4), parameter :: neginf_pat = Z'FF800000'
#else
  use shr_kind_mod, only: &
       i8 => shr_kind_i8
  integer(i8), parameter :: posinf_pat = Z'7FF0000000000000'
  integer(i8), parameter :: neginf_pat = Z'FFF0000000000000'
#endif
#endif
  real(r4), intent(out) :: output(:,:,:,:,:,:,:)
  type(shr_infnan_inf_type), intent(in) :: inf

  ! Use scalar temporary for performance reasons, to reduce the cost of
  ! the ieee_value call.
  real(r4) :: tmp

#ifdef HAVE_IEEE_ARITHMETIC
  if (inf%positive) then
     tmp = ieee_value(tmp,ieee_positive_inf)
  else
     tmp = ieee_value(tmp,ieee_negative_inf)
  end if
#else
  if (inf%positive) then
     tmp = transfer(posinf_pat, tmp)
  else
     tmp = transfer(neginf_pat, tmp)
  end if
#endif

  output = tmp

end subroutine set_inf_7d_real

end module shr_infnan_mod
